
package cz.zcu.kiv.db.dao.jdbc.model;

import java.util.List;

import cz.zcu.kiv.db.dao.OsobaDao;
import cz.zcu.kiv.db.dao.PublikaceDao;
import cz.zcu.kiv.db.dao.StudiumDao;
import cz.zcu.kiv.db.dao.TemaDao;
import cz.zcu.kiv.db.dao.UdalostDao;
import cz.zcu.kiv.db.dao.VyzkumDao;
import cz.zcu.kiv.db.model.osoby.Aktivita;
import cz.zcu.kiv.db.model.osoby.Clenstvi;
import cz.zcu.kiv.db.model.osoby.Osoba;
import cz.zcu.kiv.db.model.osoby.Pozice;
import cz.zcu.kiv.db.model.publikace.AutorstviPublikace;
import cz.zcu.kiv.db.model.studium.Tema;
import cz.zcu.kiv.db.model.studium.VyukaPredmetu;
import cz.zcu.kiv.db.model.udalosti.Udalost;
import cz.zcu.kiv.db.model.vyzkum.ClenstviVeSkupine;
import cz.zcu.kiv.db.model.vyzkum.UcastNaGrantu;

/**
 *
 * @author Radek Muzika
 */
public class JdbcOsoba extends Osoba{
    private int fkSkolitel;

    private OsobaDao _osobaDao;
    private UdalostDao _udalostDao;
    private TemaDao _temaDao;
    private VyzkumDao _vyzkumDao;
    private PublikaceDao _publikaceDao;
    private StudiumDao _studiumDao;
    
    private boolean skolitelNeni=false; 
    
    @Override
    public Osoba getSkolitel() {
        if(super.getSkolitel()==null && !skolitelNeni) {
            this.setSkolitel(_osobaDao.getOsoba(fkSkolitel));
            if(super.getSkolitel()==null) skolitelNeni = true;
        }
        return super.getSkolitel();
    }

    @Override
    public List<Aktivita> getAktivity() {
        if(super.getAktivity()==null) this.setAktivity(_osobaDao.getAktivityDleOsoby(this));
        return super.getAktivity();
    }

    @Override
    public List<AutorstviPublikace> getAutorstviPublikaci() {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    @Override
    public List<Clenstvi> getClenstvi() {
        if(super.getClenstvi()==null) this.setClenstvi(_osobaDao.getClenstviDleOsoby(this));
        return super.getClenstvi();
    }

    @Override
    public List<ClenstviVeSkupine> getClenstviVeSkupinach() {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    @Override
    public List<UcastNaGrantu> getUcastNaGrantech() {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    @Override
    public List<Tema> getGarantovanaTemata() {
        if(super.getGarantovanaTemata()==null) this.setGarantovanaTemata(_temaDao.getTemataDleOsoby(this));
        return super.getGarantovanaTemata();
    }

    @Override
    public List<Pozice> getPozice() {
        if(super.getPozice()==null) this.setPozice(_osobaDao.getPoziceDleOsoby(this));
        return super.getPozice();
    }

    @Override
    public List<Udalost> getUdalosti() {
        if(super.getUdalosti()==null) this.setUdalosti(_udalostDao.getUdalostiDleOdpovedneOsoby(this));
        return super.getUdalosti();
    }

    @Override
    public List<VyukaPredmetu> getVyukaPredmetu() {
        if(super.getVyukaPredmetu()==null) this.setVyukaPredmetu(_studiumDao.getVyukaPredmetuDleOsoby(this));
        return super.getVyukaPredmetu();
    }
    
    
    
    public int getFkSkolitel() {
        return fkSkolitel;
    }

    public void setFkSkolitel(int fkSkolitel) {
        this.fkSkolitel = fkSkolitel;
    }

    public void setOsobaDao(OsobaDao osobaDao) {
        this._osobaDao = osobaDao;
    }

    public void setUdalostDao(UdalostDao udalostDao) {
        this._udalostDao = udalostDao;
    }

    public void setTemaDao(TemaDao temaDao) {
        this._temaDao = temaDao;
    }

    public void setVyzkumDao(VyzkumDao vyzkumDao) {
        this._vyzkumDao = vyzkumDao;
    }

    public void setPublikaceDao(PublikaceDao publikaceDao) {
        this._publikaceDao = publikaceDao;
    }

    public void setStudiumDao(StudiumDao studiumDao) {
        this._studiumDao = studiumDao;
    }
    
}
